---
title: <input type="checkbox">
slug: Web/HTML/Element/input/checkbox
tags:
  - Element
  - HTML
  - HTML forms
  - Input
  - Input Types
  - Reference
  - checkbox
  - form
---
<div>{{HTMLRef}}</div>

<p>{{htmlelement("input")}} elements of type <strong><code>checkbox</code></strong> are rendered by default as boxes that are checked (ticked) when activated, like you might see in an official government paper form. The exact appearance depends upon the operating system configuration under which the browser is running. Generally this is a square but it may have rounded corners. A checkbox allows you to select single values for submission in a form (or not).</p>

<div>{{EmbedInteractiveExample("pages/tabbed/input-checkbox.html", "tabbed-standard")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples </a> and send us a pull request.</div>

<div class="note">
<p><strong>Note</strong>: <a href="/en-US/docs/Web/HTML/Element/input/radio">Radio buttons</a> are similar to checkboxes, but with an important distinction — radio buttons are grouped into a set in which only one radio button can be selected at a time, whereas checkboxes allow you to turn single values on and off. Where multiple controls exist, radio buttons allow one to be selected out of them all, whereas checkboxes allow multiple values to be selected.</p>
</div>

<table class="properties">
	<tbody>
		<tr>
			<td><strong>{{anch("Value")}}</strong></td>
			<td>A {{domxref("DOMString")}} representing the value of the checkbox.</td>
		</tr>
		<tr>
			<td><strong>Events</strong></td>
			<td>{{event("change")}} and {{event("input")}}</td>
		</tr>
		<tr>
			<td><strong>Supported common attributes</strong></td>
			<td><code>checked</code></td>
		</tr>
		<tr>
			<td><strong>IDL attributes</strong></td>
			<td><code>{{anch("checked")}}</code>, <code>{{anch("indeterminate")}}</code> and <code>{{anch("value")}}</code></td>
		</tr>
		<tr>
			<td><strong>Methods</strong></td>
			<td>{{domxref("HTMLInputElement.select", "select()")}}</td>
		</tr>
	</tbody>
</table>

<h2 id="Value">Value</h2>

<p>A {{domxref("DOMString")}} representing the value of the checkbox. This is never seen on the client-side, but on the server this is the <code>value</code> given to the data submitted with the checkbox's <code>name</code>. Take the following example:</p>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;div&gt;
    &lt;input type="checkbox" id="subscribeNews" name="subscribe" value="newsletter"&gt;
    &lt;label for="subscribeNews"&gt;Subscribe to newsletter?&lt;/label&gt;
  &lt;/div&gt;
  &lt;div&gt;
    &lt;button type="submit"&gt;Subscribe&lt;/button&gt;
  &lt;/div&gt;
&lt;/form&gt;</pre>

<p>{{EmbedLiveSample('Value', 600, 60)}}</p>

<p>In this example, we've got a name of <code>subscribe</code>, and a value of <code>newsletter</code>. When the form is submitted, the data name/value pair will be <code>subscribe=newsletter</code>.</p>

<p>If the <code>value</code> attribute was omitted, the default value for the checkbox is <code>on</code>, so the submitted data in that case would be <code>subscribe=on</code>.</p>

<div class="note">
<p><strong>Note</strong>: If a checkbox is unchecked when its form is submitted, there is no value submitted to the server to represent its unchecked state (e.g. <code>value=unchecked</code>); the value is not submitted to the server at all. If you wanted to submit a default value for the checkbox when it is unchecked, you could include an {{HTMLElement("input/hidden", '&lt;input type="hidden"&gt;')}} inside the form with the same <code>name</code> and <code>value</code>, generated by JavaScript perhaps.</p>
</div>

<h2 id="Additional_attributes">Additional attributes</h2>

<p>In addition to the common attributes shared by all {{HTMLElement("input")}} elements, "<code>checkbox</code>" inputs support the following attributes:</p>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Attribute</th>
			<th scope="col">Description</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td><code>{{anch("checked")}}</code></td>
			<td>Boolean; if present, the checkbox is toggled on by default</td>
		</tr>
		<tr>
			<td><code>{{anch("indeterminate")}}</code></td>
			<td>A Boolean which, if present, indicates that the value of the checkbox is indeterminate rather than <code>true</code> or <code>false</code></td>
		</tr>
		<tr>
			<td><code>{{anch("value")}}</code></td>
			<td>The string to use as the value of the checkbox when submitting the form, if the checkbox is currently toggled on</td>
		</tr>
	</tbody>
</table>

<h3 id="htmlattrdefchecked">{{htmlattrdef("checked")}}</h3>

<p>A Boolean attribute indicating whether or not this checkbox is checked by default (when the page loads). It does <em>not</em> indicate whether this checkbox is currently checked: if the checkbox’s state is changed, this content attribute does not reflect the change. (Only the {{domxref("HTMLInputElement")}}’s <code>checked</code> IDL attribute is updated.)</p>

<div class="note">
<p><strong>Note:</strong> Unlike other input controls, a checkboxes value is only included in the submitted data if the checkbox is currently <code>checked</code>. If it is, then the value of the checkbox's <code>value</code> attribute is reported as the input's value.</p>
</div>

<p>Unlike other browsers, Firefox by default <a href="https://stackoverflow.com/questions/5985839/bug-with-firefox-disabled-attribute-of-input-not-resetting-when-refreshing">persists the dynamic checked state</a> of an <code>&lt;input&gt;</code> across page loads. Use the {{htmlattrxref("autocomplete","input")}} attribute to control this feature.</p>

<h3 id="htmlattrdefindeterminate">{{htmlattrdef("indeterminate")}}</h3>

<p>If the <code>indeterminate</code> attribute is present on the {{HTMLElement("input")}} element defining a checkbox, the checkbox's value is neither <code>true</code> nor <code>false</code>, but is instead <strong>indeterminate</strong>, meaning that it's state cannot be determined or stated in pure binary terms. This may happen, for instance, if the state of the checkbox depends on multiple other checkboxes, and those checkboxes have different values.</p>

<p>Essentially, then, the <code>indeterminate</code> attribute adds a third possible state to the checkbox: "I don't know." In this state, the browser may draw the checkbox in grey or with a different mark inside the checkbox. For instance, browsers on macOS may draw the checkbox with a hyphen "-" inside to indicate an unexpected state.</p>

<div class="note">
<p><strong>Note:</strong> No browser currently supports <code>indeterminate</code> as an attribute. It must be set via JavaScript. See {{anch("Indeterminate state checkboxes")}} for details.</p>
</div>

<h3 id="htmlattrdefvalue">{{htmlattrdef("value")}}</h3>

<p>The <code>value</code> attribute is one which all {{HTMLElement("input")}}s share; however, it serves a special purpose for inputs of type <code>checkbox</code>: when a form is submitted, only checkboxes which are currently checked are submitted to the server, and the reported value is the value of the <code>value</code> attribute. If the <code>value</code> is not otherwise specified, it is the string <code>on</code> by default. This is demonstrated in the section {{anch("Value")}} above.</p>

<h2 id="Using_checkbox_inputs">Using checkbox inputs</h2>

<p>We already covered the most basic use of checkboxes above. Let's now look at the other common checkbox-related features and techniques you'll need.</p>

<h3 id="Handling_multiple_checkboxes">Handling multiple checkboxes</h3>

<p>The example we saw above only contained one checkbox; in real-world situations you'll be likely to encounter multiple checkboxes. If they are completely unrelated, then you can just deal with them all separately, as shown above. However, if they're all related, things are not quite so simple.</p>

<p>For example, in the following demo we include multiple checkboxes to allow the user to select their interests (see the full version in the {{anch("Examples")}} section).</p>

<pre class="brush: html notranslate">&lt;fieldset&gt;
  &lt;legend&gt;Choose your interests&lt;/legend&gt;
  &lt;div&gt;
    &lt;input type="checkbox" id="coding" name="interest" value="coding"&gt;
    &lt;label for="coding"&gt;Coding&lt;/label&gt;
  &lt;/div&gt;
  &lt;div&gt;
    &lt;input type="checkbox" id="music" name="interest" value="music"&gt;
    &lt;label for="music"&gt;Music&lt;/label&gt;
  &lt;/div&gt;
&lt;/fieldset&gt;</pre>

<p>{{EmbedLiveSample('Handling_multiple_checkboxes', 600, 100)}}</p>

<p>In this example you will see that we've given each checkbox the same <code>name</code>. If both checkboxes are checked and then the form is submitted, you'll get a string of name/value pairs submitted like this: <code>interest=coding&amp;interest=music</code>. When this string reaches the server, you need to parse it other than as an associative array, so all values, not only the last value, of <code>interest</code> are captured. For one technique used with PHP, see <a class="question-hyperlink" href="http://stackoverflow.com/questions/18745456/handle-multiple-checkboxes-with-a-single-serverside-variable">Handle Multiple Checkboxes with a Single Serverside Variable</a>, for example.</p>

<h3 id="Checking_boxes_by_default">Checking boxes by default</h3>

<p>To make a checkbox checked by default, you give it the <code>checked</code> attribute. See the below example:</p>

<pre class="brush: html notranslate">&lt;fieldset&gt;
  &lt;legend&gt;Choose your interests&lt;/legend&gt;
  &lt;div&gt;
    &lt;input type="checkbox" id="coding" name="interest" value="coding" checked&gt;
    &lt;label for="coding"&gt;Coding&lt;/label&gt;
  &lt;/div&gt;
  &lt;div&gt;
    &lt;input type="checkbox" id="music" name="interest" value="music"&gt;
    &lt;label for="music"&gt;Music&lt;/label&gt;
  &lt;/div&gt;
&lt;/fieldset&gt;</pre>

<p>{{EmbedLiveSample('Checking_boxes_by_default', 600, 100)}}</p>

<h3 id="Providing_a_bigger_hit_area_for_your_checkboxes">Providing a bigger hit area for your checkboxes</h3>

<p>In the above examples, you may have noticed that you can toggle a checkbox by clicking on its associated {{htmlelement("label")}} element as well as on the checkbox itself. This is a really useful feature of HTML form labels that makes it easier to click the option you want, especially on small-screen devices like smartphones.</p>

<p>Beyond accessibility, this is another good reason to properly set up <code>&lt;label&gt;</code> elements on your forms.</p>

<h3 id="Indeterminate_state_checkboxes">Indeterminate state checkboxes</h3>

<p>In addition to the checked and unchecked states, there is a third state a checkbox can be in: <strong>indeterminate</strong>. This is a state in which it's impossible to say whether the item is toggled on or off. This is set using the {{domxref("HTMLInputElement")}} object's <code>indeterminate</code> property via JavaScript (it cannot be set using an HTML attribute):</p>

<pre class="brush: js notranslate">inputInstance.indeterminate = true;</pre>

<p>A checkbox in the indeterminate state has a horizontal line in the box (it looks somewhat like a hyphen or minus sign) instead of a check/tick in most browsers.</p>

<p>There are not many use cases for this property. The most common is when a checkbox is available that "owns" a number of sub-options (which are also checkboxes). If all of the sub-options are checked, the owning checkbox is also checked, and if they're all unchecked, the owning checkbox is unchecked. If any one or more of the sub-options have a different state than the others, the owning checkbox is in the indeterminate state.</p>

<p>This can be seen in the below example (thanks to <a href="https://css-tricks.com/indeterminate-checkboxes/">CSS Tricks</a> for the inspiration). In this example we keep track of the ingredients we are collecting for a recipe. When you check or uncheck an ingredient's checkbox, a JavaScript function checks the total number of checked ingredients:</p>

<ul>
	<li>If none are checked, the recipe name's checkbox is set to unchecked.</li>
	<li>If one or two are checked, the recipe name's checkbox is set to <code>indeterminate</code>.</li>
	<li>If all three are checked, the recipe name's checkbox is set to <code>checked</code>.</li>
</ul>

<p>So in this case the <code>indeterminate</code> state is used to state that collecting the ingredients has started, but the recipe is not yet complete.</p>

<pre class="brush: js notranslate" id="line1">  var overall = document.querySelector('input[id="EnchTbl"]');
  var ingredients = document.querySelectorAll('ul input');

  overall.addEventListener('click', function(e) {
    e.preventDefault();
  });

  for(var i = 0; i &lt; ingredients.length; i++) {
    ingredients[i].addEventListener('click', updateDisplay);
  }

  function updateDisplay() {
    var checkedCount = 0;
    for(var i = 0; i &lt; ingredients.length; i++) {
      if(ingredients[i].checked) {
        checkedCount++;
      }
    }

    if(checkedCount === 0) {
      overall.checked = false;
      <strong>overall.indeterminate = false;</strong>
    } else if(checkedCount === ingredients.length) {
      overall.checked = true;
      <strong>overall.indeterminate = false;</strong>
    } else {
      overall.checked = false;
      <strong>overall.indeterminate = true;</strong>
    }
  }</pre>

<p>{{EmbedGHLiveSample("learning-area/html/forms/indeterminate-example/index.html", '100%', 200)}}</p>

<div class="note">
<p><strong>Note</strong>: If you submit a form with an indeterminate checkbox, the same thing happens as if the checkbox were unchecked — no data is submitted to represent the checkbox.</p>
</div>

<h2 id="Validation">Validation</h2>

<p>Checkboxes do support <a href="/en-US/docs/Web/Guide/HTML/HTML5/Constraint_validation">validation</a> (offered to all {{HTMLElement("input")}}s). However, most of the {{domxref("ValidityState")}}s will always be <code>false</code>. If the checkbox has the {{htmlattrxref("required", "input")}} attribute, but is not checked, then {{domxref("ValidityState.valueMissing")}} will be <code>true</code>.</p>

<h2 id="Examples">Examples</h2>

<p>The following example is an extended version of the "multiple checkboxes" example we saw above — it has more standard options, plus an "other" checkbox that when checked causes a text field to appear to enter a value for the "other" option. This is achieved with a simple block of JavaScript. The example also includes some CSS to improve the styling.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;form&gt;
  &lt;fieldset&gt;
  &lt;legend&gt;Choose your interests&lt;/legend&gt;
    &lt;div&gt;
      &lt;input type="checkbox" id="coding" name="interest" value="coding"&gt;
      &lt;label for="coding"&gt;Coding&lt;/label&gt;
    &lt;/div&gt;
    &lt;div&gt;
      &lt;input type="checkbox" id="music" name="interest" value="music"&gt;
      &lt;label for="music"&gt;Music&lt;/label&gt;
    &lt;/div&gt;
    &lt;div&gt;
      &lt;input type="checkbox" id="art" name="interest" value="art"&gt;
      &lt;label for="art"&gt;Art&lt;/label&gt;
    &lt;/div&gt;
    &lt;div&gt;
      &lt;input type="checkbox" id="sports" name="interest" value="sports"&gt;
      &lt;label for="sports"&gt;Sports&lt;/label&gt;
    &lt;/div&gt;
    &lt;div&gt;
      &lt;input type="checkbox" id="cooking" name="interest" value="cooking"&gt;
      &lt;label for="cooking"&gt;Cooking&lt;/label&gt;
    &lt;/div&gt;
    &lt;div&gt;
      &lt;input type="checkbox" id="other" name="interest" value="other"&gt;
      &lt;label for="other"&gt;Other&lt;/label&gt;
      &lt;input type="text" id="otherValue" name="other"&gt;
    &lt;/div&gt;
    &lt;div&gt;
      &lt;button type="submit"&gt;Submit form&lt;/button&gt;
    &lt;/div&gt;
  &lt;/fieldset&gt;
&lt;/form&gt;</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">html {
  font-family: sans-serif;
}

form {
  width: 600px;
  margin: 0 auto;
}

div {
  margin-bottom: 10px;
}

fieldset {
  background: cyan;
  border: 5px solid blue;
}

legend {
  padding: 10px;
  background: blue;
  color: cyan;
}
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">var otherCheckbox = document.querySelector('input[value="other"]');
var otherText = document.querySelector('input[id="otherValue"]');
otherText.style.visibility = 'hidden';

otherCheckbox.addEventListener('change', () =&gt; {
  if(otherCheckbox.checked) {
    otherText.style.visibility = 'visible';
    otherText.value = '';
  } else {
    otherText.style.visibility = 'hidden';
  }
});</pre>

<p>{{EmbedLiveSample('Examples', '100%', 300)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('HTML WHATWG', 'forms.html#checkbox-state-(type=checkbox)', '&lt;input type="checkbox"&gt;')}}</td>
			<td>{{Spec2('HTML WHATWG')}}</td>
			<td></td>
		</tr>
		<tr>
			<td>{{SpecName('HTML5 W3C', 'forms.html#checkbox-state-(type=checkbox)', '&lt;input type="checkbox"&gt;')}}</td>
			<td>{{Spec2('HTML5 W3C')}}</td>
			<td></td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.input.input-checkbox")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{HTMLElement("input")}} and the {{domxref("HTMLInputElement")}} interface which implements it.</li>
	<li>The {{cssxref(":checked")}} and {{cssxref(":indeterminate")}} CSS selectors let you style checkboxes based on their current state</li>
	<li><a href="/en-US/docs/Learn/Forms/Property_compatibility_table_for_form_controls">Compatibility of CSS properties</a></li>
</ul>
